<template>
  <Head title="Permissions" />

  <Layout>
    <div class="max-w-full mx-auto sm:px-2 lg:px-2">
      <div class="lg:flex lg:items-center lg:justify-between">
        <div class="flex-1 min-w-0">
          <!-- {/* Title Page */} -->
          <h2
            class="
              text-2xl
              font-semibold
              text-gray-700
              dark:text-gray-200
              sm:text-3xl
              sm:truncate
            "
          >
            Permissions
          </h2>
          <!-- {/* Breadcumb */} -->
          <div
            class="
              mt-1
              flex flex-col
              sm:flex-row sm:flex-wrap
              sm:mt-0
              sm:space-x-6
            "
          >
            <ul class="flex text-gray-900 text-sm lg:text-base">
              <li class="inline-flex items-center">
                <Link :href="route('dashboard')">Dashboard</Link>
                <Icon
                  :name="`chevron-right`"
                  :style="`h-5 w-auto text-gray-400`"
                />
              </li>
              <li class="inline-flex items-center">
                <Link :href="route('permission')" class="text-gray-500">
                  Permissions
                </Link>
              </li>
            </ul>
          </div>
        </div>
        <div class="mt-5 flex lg:mt-0 lg:ml-4"></div>
      </div>

      <div class="flex items-center justify-between mb-6">
        <div class="my-2 flex sm:flex-row flex-col"></div>
        <Link
          v-if="$page.props.auth.can.create_permission"
          class="
            flex
            right-0
            items-center
            px-4
            py-2
            border border-transparent
            rounded-md
            shadow-sm
            text-sm
            font-medium
            text-white
            bg-yellow-600
            hover:bg-yellow-700
            focus:outline-none
            focus:ring-2 focus:ring-offset-2 focus:ring-yellow-500
          "
          :href="route('permission.create')"
        >
          <Icon :name="`pencil-add`" :style="`-ml-1 mr-2 h-5 w-5`" />
          <span class="hidden md:inline">Add New</span>
        </Link>
      </div>

      <div class="w-full overflow-hidden rounded-lg shadow-xs">
        <div class="w-full overflow-x-auto">
          <table class="w-full whitespace-no-wrap">
            <thead>
              <tr
                class="
                  text-xs
                  font-semibold
                  tracking-wide
                  text-left text-gray-500
                  uppercase
                  border-b
                  bg-gray-100
                  dark:border-gray-700
                  dark:text-gray-400
                  dark:bg-gray-800
                "
              >
                <th class="px-4 py-3 text-left w-48">Name</th>
                <th class="px-4 py-3">Description</th>

                <th
                  v-if="
                    $page.props.auth.can.update_permission ||
                    $page.props.auth.can.delete_permission
                  "
                  class="px-4 py-3 text-center w-40"
                >
                  Action
                </th>
              </tr>
            </thead>
            <tbody
              class="bg-white divide-y dark:divide-gray-700 dark:bg-gray-800"
            >
              <tr
                v-for="permission in permissions.data"
                :key="permission.id"
                class="text-gray-700 dark:text-gray-400"
              >
                <td class="px-4 py-3 text-left text-sm font-semibold">
                  {{ permission.name }}
                </td>
                <td class="px-4 py-3 text-sm">
                  {{ permission.description }}
                </td>
                <td
                  v-if="
                    $page.props.auth.can.update_permission ||
                    $page.props.auth.can.delete_permission
                  "
                  class="px-4 py-3 text-center"
                >
                  <div class="flex item-center justify-center">
                    <Link
                      v-if="$page.props.auth.can.update_permission"
                      :href="route('permission.edit', permission.id)"
                      class="
                        w-5
                        mr-2
                        transform
                        hover:text-yellow-500
                        hover:scale-110
                      "
                    >
                      <Icon
                        :name="`pencil-edit`"
                        :style="`w-5 mr-2 transform hover:text-yellow-500 hover:scale-110`"
                      />
                    </Link>
                    <button
                      v-if="$page.props.auth.can.delete_permission"
                      @click="setIsOpen(true, permission.id)"
                      class="
                        w-5
                        mr-2
                        text-right
                        transform
                        hover:text-red-500
                        hover:scale-110
                      "
                    >
                      <Icon
                        :name="`trash`"
                        :style="`w-5 mr-2 text-right transform hover:text-red-500 hover:scale-110`"
                      />
                    </button>
                  </div>
                </td>
              </tr>
              <tr v-if="permissions.data.length === 0">
                <td class="border-t px-6 py-4" colspan="4">
                  No Permission found.
                </td>
              </tr>
            </tbody>
          </table>
        </div>

        <!-- Pagination -->
        <pagination
          :links="permissions.links"
          :from="permissions.from"
          :to="permissions.to"
          :total="permissions.total"
        />
        <!-- Pagination -->

        <ModalConfirm
          ref="modalConfirm"
          :title="`Delete Data Permission`"
          :message="`Are you sure you want to delete this data? All of your data will be permanently removed. This action cannot be undone.`"
          :showModal="isOpen"
          :closeModal="closeModal"
          @onConfirm="onConfirmDelete"
        />
      </div>
    </div>
  </Layout>
</template>

<script>
import { ref } from "vue";
import Layout from "@/Layouts/App.vue";
import { Inertia } from "@inertiajs/inertia";
import { Head, Link } from "@inertiajs/inertia-vue3";
import Icon from "@/Components/Icon";
import Input from "@/Components/Input.vue";
import Pagination from "@/Components/Pagination.vue";
import ModalConfirm from "@/Components/Modal/ModalConfirm.vue";
export default {
  components: {
    Layout,
    Head,
    Link,
    Input,
    Icon,
    Pagination,
    ModalConfirm,
  },
  props: {
    permissions: Object,
  },
  setup(props) {
    let isOpen = ref(false);
    let permissionId = ref(null);

    let onConfirmDelete = () => {
      Inertia.delete(route("permission.destroy", permissionId.value), {
        onSuccess: () => {
          isOpen.value = false;
        },
      });
    };
    return {
      isOpen,
      onConfirmDelete,
      setIsOpen(value, id) {
        isOpen.value = value;
        permissionId.value = id;
      },
      closeModal() {
        isOpen.value = false;
      },
    };
  },
};
</script>
